import{s as Pe,n as Se,o as Ee}from"../chunks/scheduler.00bde567.js";import{S as ze,i as Ae,g as n,s as l,r as $,A as Ie,h as s,f as t,c as o,j as m,u as y,x as L,k as c,y as i,a as r,v as x,d as w,t as N,w as M}from"../chunks/index.752e2ff6.js";import{D as C}from"../chunks/Docstring.d4f10c97.js";import{H as Ve}from"../chunks/Heading.476d3364.js";function ke(ye){let p,J,H,K,D,Q,g,T,ue,k,xe=`Plugin for Megatron-LM to enable tensor, pipeline, sequence and data parallelism. Also to enable selective
activation recomputation and optimized fused kernels.`,W,u,P,de,q,we=`Dummy scheduler presents model parameters or param groups, this is primarily used to follow conventional training
loop when scheduler config is specified in the deepspeed config file.`,X,d,S,_e,O,Ne="Dummy dataloader presents model parameters or param groups, this is primarily used to follow conventional training",Y,_,E,ve,U,Me="Abstract class for batching, forward pass and loss handler.",Z,v,z,fe,B,Le="GPT train step class.",ee,f,A,he,G,Ce="Bert train step class.",te,h,I,be,F,De="T5 train step class.",ae,b,V,$e,j,Te="Average losses across data parallel group.",re,R,ne;return D=new Ve({props:{title:"Utilities for Megatron-LM",local:"accelerate.utils.MegatronLMPlugin",headingTag:"h1"}}),T=new C({props:{name:"class accelerate.utils.MegatronLMPlugin",anchor:"accelerate.utils.MegatronLMPlugin",parameters:[{name:"tp_degree",val:": int = None"},{name:"pp_degree",val:": int = None"},{name:"num_micro_batches",val:": int = None"},{name:"gradient_clipping",val:": float = None"},{name:"sequence_parallelism",val:": bool = None"},{name:"recompute_activations",val:": bool = None"},{name:"use_distributed_optimizer",val:": bool = None"},{name:"pipeline_model_parallel_split_rank",val:": int = None"},{name:"num_layers_per_virtual_pipeline_stage",val:": int = None"},{name:"is_train_batch_min",val:": str = True"},{name:"train_iters",val:": int = None"},{name:"train_samples",val:": int = None"},{name:"weight_decay_incr_style",val:": str = 'constant'"},{name:"start_weight_decay",val:": float = None"},{name:"end_weight_decay",val:": float = None"},{name:"lr_decay_style",val:": str = 'linear'"},{name:"lr_decay_iters",val:": int = None"},{name:"lr_decay_samples",val:": int = None"},{name:"lr_warmup_iters",val:": int = None"},{name:"lr_warmup_samples",val:": int = None"},{name:"lr_warmup_fraction",val:": float = None"},{name:"min_lr",val:": float = 0"},{name:"consumed_samples",val:": typing.List[int] = None"},{name:"no_wd_decay_cond",val:": typing.Optional[typing.Callable] = None"},{name:"scale_lr_cond",val:": typing.Optional[typing.Callable] = None"},{name:"lr_mult",val:": float = 1.0"},{name:"megatron_dataset_flag",val:": bool = False"},{name:"seq_length",val:": int = None"},{name:"encoder_seq_length",val:": int = None"},{name:"decoder_seq_length",val:": int = None"},{name:"tensorboard_dir",val:": str = None"},{name:"set_all_logging_options",val:": bool = False"},{name:"eval_iters",val:": int = 100"},{name:"eval_interval",val:": int = 1000"},{name:"return_logits",val:": bool = False"},{name:"custom_train_step_class",val:": typing.Optional[typing.Any] = None"},{name:"custom_train_step_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"custom_model_provider_function",val:": typing.Optional[typing.Callable] = None"},{name:"custom_prepare_model_function",val:": typing.Optional[typing.Callable] = None"},{name:"other_megatron_args",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],source:"https://github.com/huggingface/accelerate/blob/v0.25.0/src/accelerate/utils/dataclasses.py#L1030"}}),P=new C({props:{name:"class accelerate.utils.MegatronLMDummyScheduler",anchor:"accelerate.utils.MegatronLMDummyScheduler",parameters:[{name:"optimizer",val:""},{name:"total_num_steps",val:" = None"},{name:"warmup_num_steps",val:" = 0"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"accelerate.utils.MegatronLMDummyScheduler.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.optimizer.Optimizer</code>) &#x2014;
The optimizer to wrap.`,name:"optimizer"},{anchor:"accelerate.utils.MegatronLMDummyScheduler.total_num_steps",description:`<strong>total_num_steps</strong> (int) &#x2014;
Total number of steps.`,name:"total_num_steps"},{anchor:"accelerate.utils.MegatronLMDummyScheduler.warmup_num_steps",description:`<strong>warmup_num_steps</strong> (int) &#x2014;
Number of steps for warmup.
**kwargs &#x2014;
Other arguments.`,name:"warmup_num_steps"}],source:"https://github.com/huggingface/accelerate/blob/v0.25.0/src/accelerate/utils/megatron_lm.py#L414"}}),S=new C({props:{name:"class accelerate.utils.MegatronLMDummyDataLoader",anchor:"accelerate.utils.MegatronLMDummyDataLoader",parameters:[{name:"**dataset_kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.25.0/src/accelerate/utils/megatron_lm.py#L144"}}),E=new C({props:{name:"class accelerate.utils.AbstractTrainStep",anchor:"accelerate.utils.AbstractTrainStep",parameters:[{name:"name",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.25.0/src/accelerate/utils/megatron_lm.py#L451"}}),z=new C({props:{name:"class accelerate.utils.GPTTrainStep",anchor:"accelerate.utils.GPTTrainStep",parameters:[{name:"args",val:""}],parametersDescription:[{anchor:"accelerate.utils.GPTTrainStep.args",description:"<strong>args</strong> (<code>argparse.Namespace</code>) &#x2014; Megatron-LM arguments.",name:"args"}],source:"https://github.com/huggingface/accelerate/blob/v0.25.0/src/accelerate/utils/megatron_lm.py#L597"}}),A=new C({props:{name:"class accelerate.utils.BertTrainStep",anchor:"accelerate.utils.BertTrainStep",parameters:[{name:"args",val:""}],parametersDescription:[{anchor:"accelerate.utils.BertTrainStep.args",description:"<strong>args</strong> (<code>argparse.Namespace</code>) &#x2014; Megatron-LM arguments.",name:"args"}],source:"https://github.com/huggingface/accelerate/blob/v0.25.0/src/accelerate/utils/megatron_lm.py#L468"}}),I=new C({props:{name:"class accelerate.utils.T5TrainStep",anchor:"accelerate.utils.T5TrainStep",parameters:[{name:"args",val:""}],parametersDescription:[{anchor:"accelerate.utils.T5TrainStep.args",description:"<strong>args</strong> (<code>argparse.Namespace</code>) &#x2014; Megatron-LM arguments.",name:"args"}],source:"https://github.com/huggingface/accelerate/blob/v0.25.0/src/accelerate/utils/megatron_lm.py#L703"}}),V=new C({props:{name:"accelerate.utils.avg_losses_across_data_parallel_group",anchor:"accelerate.utils.avg_losses_across_data_parallel_group",parameters:[{name:"losses",val:""}],parametersDescription:[{anchor:"accelerate.utils.avg_losses_across_data_parallel_group.losses",description:"<strong>losses</strong> (List[Tensor]) &#x2014; List of losses to average across data parallel group.",name:"losses"}],source:"https://github.com/huggingface/accelerate/blob/v0.25.0/src/accelerate/utils/megatron_lm.py#L1408"}}),{c(){p=n("meta"),J=l(),H=n("p"),K=l(),$(D.$$.fragment),Q=l(),g=n("div"),$(T.$$.fragment),ue=l(),k=n("p"),k.textContent=xe,W=l(),u=n("div"),$(P.$$.fragment),de=l(),q=n("p"),q.textContent=we,X=l(),d=n("div"),$(S.$$.fragment),_e=l(),O=n("p"),O.textContent=Ne,Y=l(),_=n("div"),$(E.$$.fragment),ve=l(),U=n("p"),U.textContent=Me,Z=l(),v=n("div"),$(z.$$.fragment),fe=l(),B=n("p"),B.textContent=Le,ee=l(),f=n("div"),$(A.$$.fragment),he=l(),G=n("p"),G.textContent=Ce,te=l(),h=n("div"),$(I.$$.fragment),be=l(),F=n("p"),F.textContent=De,ae=l(),b=n("div"),$(V.$$.fragment),$e=l(),j=n("p"),j.textContent=Te,re=l(),R=n("p"),this.h()},l(e){const a=Ie("svelte-u9bgzb",document.head);p=s(a,"META",{name:!0,content:!0}),a.forEach(t),J=o(e),H=s(e,"P",{}),m(H).forEach(t),K=o(e),y(D.$$.fragment,e),Q=o(e),g=s(e,"DIV",{class:!0});var le=m(g);y(T.$$.fragment,le),ue=o(le),k=s(le,"P",{"data-svelte-h":!0}),L(k)!=="svelte-51ubws"&&(k.textContent=xe),le.forEach(t),W=o(e),u=s(e,"DIV",{class:!0});var se=m(u);y(P.$$.fragment,se),de=o(se),q=s(se,"P",{"data-svelte-h":!0}),L(q)!=="svelte-mxz6g6"&&(q.textContent=we),se.forEach(t),X=o(e),d=s(e,"DIV",{class:!0});var oe=m(d);y(S.$$.fragment,oe),_e=o(oe),O=s(oe,"P",{"data-svelte-h":!0}),L(O)!=="svelte-1r57fhg"&&(O.textContent=Ne),oe.forEach(t),Y=o(e),_=s(e,"DIV",{class:!0});var ie=m(_);y(E.$$.fragment,ie),ve=o(ie),U=s(ie,"P",{"data-svelte-h":!0}),L(U)!=="svelte-7ith7r"&&(U.textContent=Me),ie.forEach(t),Z=o(e),v=s(e,"DIV",{class:!0});var me=m(v);y(z.$$.fragment,me),fe=o(me),B=s(me,"P",{"data-svelte-h":!0}),L(B)!=="svelte-8o1bfn"&&(B.textContent=Le),me.forEach(t),ee=o(e),f=s(e,"DIV",{class:!0});var ce=m(f);y(A.$$.fragment,ce),he=o(ce),G=s(ce,"P",{"data-svelte-h":!0}),L(G)!=="svelte-1af56j7"&&(G.textContent=Ce),ce.forEach(t),te=o(e),h=s(e,"DIV",{class:!0});var pe=m(h);y(I.$$.fragment,pe),be=o(pe),F=s(pe,"P",{"data-svelte-h":!0}),L(F)!=="svelte-1w9r8gv"&&(F.textContent=De),pe.forEach(t),ae=o(e),b=s(e,"DIV",{class:!0});var ge=m(b);y(V.$$.fragment,ge),$e=o(ge),j=s(ge,"P",{"data-svelte-h":!0}),L(j)!=="svelte-39hqbl"&&(j.textContent=Te),ge.forEach(t),re=o(e),R=s(e,"P",{}),m(R).forEach(t),this.h()},h(){c(p,"name","hf:doc:metadata"),c(p,"content",qe),c(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){i(document.head,p),r(e,J,a),r(e,H,a),r(e,K,a),x(D,e,a),r(e,Q,a),r(e,g,a),x(T,g,null),i(g,ue),i(g,k),r(e,W,a),r(e,u,a),x(P,u,null),i(u,de),i(u,q),r(e,X,a),r(e,d,a),x(S,d,null),i(d,_e),i(d,O),r(e,Y,a),r(e,_,a),x(E,_,null),i(_,ve),i(_,U),r(e,Z,a),r(e,v,a),x(z,v,null),i(v,fe),i(v,B),r(e,ee,a),r(e,f,a),x(A,f,null),i(f,he),i(f,G),r(e,te,a),r(e,h,a),x(I,h,null),i(h,be),i(h,F),r(e,ae,a),r(e,b,a),x(V,b,null),i(b,$e),i(b,j),r(e,re,a),r(e,R,a),ne=!0},p:Se,i(e){ne||(w(D.$$.fragment,e),w(T.$$.fragment,e),w(P.$$.fragment,e),w(S.$$.fragment,e),w(E.$$.fragment,e),w(z.$$.fragment,e),w(A.$$.fragment,e),w(I.$$.fragment,e),w(V.$$.fragment,e),ne=!0)},o(e){N(D.$$.fragment,e),N(T.$$.fragment,e),N(P.$$.fragment,e),N(S.$$.fragment,e),N(E.$$.fragment,e),N(z.$$.fragment,e),N(A.$$.fragment,e),N(I.$$.fragment,e),N(V.$$.fragment,e),ne=!1},d(e){e&&(t(J),t(H),t(K),t(Q),t(g),t(W),t(u),t(X),t(d),t(Y),t(_),t(Z),t(v),t(ee),t(f),t(te),t(h),t(ae),t(b),t(re),t(R)),t(p),M(D,e),M(T),M(P),M(S),M(E),M(z),M(A),M(I),M(V)}}}const qe='{"title":"Utilities for Megatron-LM","local":"accelerate.utils.MegatronLMPlugin","sections":[],"depth":1}';function Oe(ye){return Ee(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class je extends ze{constructor(p){super(),Ae(this,p,Oe,ke,Pe,{})}}export{je as component};
